new;
library pgraph;

#include copula.src;

rndseed 123456;

tau1 = 0.20;    /* small dependence */
tau2 = 0.80;    /* big dependence */
tau = tau1~tau2;

Ns = 500; Nr = 2;

rho = sin(pi/2*tau);         /* Corresponding parameter for the Normal copula */
alpha = 1./(1-tau);          /* Corresponding parameter for the Gumbel copula */


{u1,u2} = rndNormal2Copula(Ns,Nr,rho);
x1 = cdftci(1-u1,3);
x2 = cdftci(1-u2,7);

{u1,u2} = rndGumbelCopula(Ns,Nr,alpha);
x3 = cdftci(1-u1,3);
x4 = cdftci(1-u2,7);

graphset;
  begwind;
  window(2,2,0);

  _pdate = ""; _pnum = 2; _pframe = 0;
  _paxht = 0.20; _ptitlht = 0.20;
  _plctrl = -1; _pcross = 1;
  fonts("simplex simgrma");
  xlabel("\214t]3[");
  ylabel("\214t]7[");
  xtics(-8,8,2,0);
  ytics(-6,6,2,0);
  
  setwind(1);
    title("Normal copula with \202t\201 = 0.20");
    xy(x1[.,1],x2[.,1]);

  setwind(2);
    title("Normal copula with \202t\201 = 0.80");
    xy(x1[.,2],x2[.,2]);

  setwind(3);
    title("Gumbel copula with \202t\201 = 0.20");
    xy(x3[.,1],x4[.,1]);

  setwind(4);
    title("Gumbel copula with \202t\201 = 0.80");
    xy(x3[.,2],x4[.,2]);

    graphprt("-c=1 -cf=copula2.ps");

  endwind;
