new;
library optmum;

rndseed 123;


#include mlegev.src;
#include gev.src;

data = loadd("cac-dj");

CAC40 = data[.,2];        /* CAC 40 */
DJ = data[.,3];           /* Dow Jones */

y = packr(CAC40~DJ);
let Portfolio[4,2] = 1 0 
                     0 1
                     1 1
                     1 -1;
data = ln(y*Portfolio');
r = real(data - lag1(data));
Nobs = rows(r);

varphi = 22;       /* one month of trading */

let alphaVaR[1,3] = 0.99 0.996 0.999;
tau = 1./(1-alphaVaR);
alphaGEV = 1 - (1./tau*varphi);

let sv = 0;

__output = 1;

VaR1 = zeros(4,3);
VaR2 = zeros(4,3);
VaR3 = zeros(4,3);

i = 1;
do until i > 4;

  mu = meanc(packr(r[.,i]));
  sigma = stdc(packr(r[.,i]));
  
  VaR1[i,.] = sigma*cdfni(alphaVaR);                  /* Gaussian VaR   */

  VaR2[i,.] = -quantile(packr(r[.,i]),1-alphaVaR')';  /* Historical VaR */

  block = reshape(r[.,i],Nobs/varphi,varphi)';
  min = -minc(block);
  {mu,sigma,xi} = mleGEV(min,sv);
  VaR3[i,.] = cdfGEVi(alphaGEV,mu,sigma,xi);          /* GEV VaR        */

  i = i + 1;
endo;

output file = gev2.out reset;

call printfm(100*VaR1,1,"%lf"~8~3); print;
call printfm(100*VaR2,1,"%lf"~8~3); print;
call printfm(100*VaR3,1,"%lf"~8~3); print;

output off;